/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package myllk;

import java.util.*;

public class Map {

    private int map[][] = new int[Setting.Row + 2][Setting.Col + 2];
    private int numberOfPoints;

    public Map(int elementNum) {
        try {
            if (4 * elementNum > Setting.Col * Setting.Row) {  //每一个元素至少出现四次
                throw new Exception("Too many Element");
            }
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        this.numberOfPoints = elementNum * 4;
        InitalMap();
    }

    private void disSequence(int array[]) {
        for (int i = array.length; i > 0; i--) {
            Random random = new Random();
            int num = random.nextInt(i);
            int tmp = array[num];
            array[num] = array[i - 1];
            array[i - 1] = tmp;
        }
    }

    private void InitalMap() {
        //设置外围区域元素全部为0
        for (int i = 0; i <= Setting.Row + 1; i++) {
            map[i][0] = 0;
            map[i][Setting.Col] = 0;
        }
        for (int j = 0; j <= Setting.Col + 1; j++) {
            map[0][j] = 0;
            map[Setting.Row][j] = 0;
        }
        int temp[] = new int[Setting.Col * Setting.Row];
        for (int i = 0; i < Setting.Col * Setting.Row; i += 4) {
            temp[i] = i / 4;
            temp[i + 1] = i / 4;
            temp[i + 2] = i / 4;
            temp[i + 3] = i / 4;
        }
        this.disSequence(temp);
        for (int i = 0; i < Setting.Row; i++) {
            for (int j = 0; j < Setting.Col; j++) {
                map[i + 1][j + 1] = temp[i * Setting.Row + j];
            }
        }
        show();
    }

    private void show() {
        for (int i = 0; i < Setting.Row + 1; i++) {
            for (int j = 0; j < Setting.Col + 1; j++) {
                System.out.print(map[i][j] + "\t");
            }
            System.out.println();
        }
    }

    public boolean canBeRelease(Point a, Point b) {
        if (map[a.x][a.y] == map[b.x][b.y]&&map[a.x][a.y]!=0) {
            return onOneLine(a, b) //可以由一条线连接
                    || OnTwoLine(a, b) //可以由两条线连接
                    || OnThreeLine(a, b);        //可以由三条线连接
        }
        return false;
    }

    private boolean onOneLine(Point a, Point b) {
        if (a.x == b.x) {           //在水平方向上可以消除,检查同一行上的每一列
            int min = a.y < b.y ? a.y : b.y;
            int max = a.y > b.y ? a.y : b.y;

            for (int i = min + 1; i < max; i++) {
                if (map[a.x][i] != 0) {
                    return false;
                }
            }
            return true;
        }
        if (a.y == b.y) {           //在垂直方向上可以消除，检查同一列上每一行上的值
            int min = a.x < b.x ? a.x : b.x;
            int max = a.x > b.x ? a.x : b.x;

            for (int i = min + 1; i < max; i++) {
                if (map[i][a.y] != 0) {
                    return false;
                }
            }
            return true;
        }
        return false;
    }

    private boolean OnTwoLine(Point a, Point b) {
        //分别以a、b横纵坐标建立新的点
        Point c = new Point(a.x, b.y);
        Point d = new Point(b.x, a.y);
        return map[c.x][c.y] == 0 && this.onOneLine(a, c) && this.onOneLine(c, b)
                || map[d.x][d.y] == 0 && this.onOneLine(a, d) && this.onOneLine(d, b);
    }

    private boolean OnThreeLine(Point a, Point b) {
        //这种方法中三条线包含两条线的情况
        /*
        方向一、
        找到与a在同一水平线上且与a相通的一点c
        验证c点映射到与b在同一水平线上的一点d是否相通
        验证d能否与b相通
         */
        for (int i = 0; i <= Setting.Col + 1; i++) {
            if (map[a.x][i] == 0 && this.onOneLine(new Point(a.x, i), a)) {
                Point c = new Point(a.x, i);
                if (map[b.x][i] == 0 && this.onOneLine(c, new Point(b.x, i))) {
                    Point d = new Point(b.x, i);
                    if (this.onOneLine(d, b)) {
                        return true;
                    }
                }
            }
        }
        for (int i = 0; i <= Setting.Row + 1; i++) {
            if (map[i][a.y] == 0 && this.onOneLine(new Point(i, a.y), a)) {
                Point c = new Point(i, a.y);
                if (map[i][b.y] == 0 && this.onOneLine(c, new Point(i, b.y))) {
                    Point d = new Point(i, b.y);
                    if (this.onOneLine(d, b)) {
                        return true;
                    }
                }
            }
        }
        return false;
    }

    public void Release(Point a, Point b) {
        map[a.x][a.y] = 0;
        map[b.x][b.y] = 0;
        show();
    }

    public int[][] getMap() {
        return map;
    }
}
